!TO "FLYING_ECK.PRG",CBM


*=$428B

main:	JSR INILCD  	;LCD INITIALISIEREN
		JSR CLRLCD

		LDA #$01
		STA $200
		LDA #$00
		STA $201

clral:
		LDA #$00
		STA $205		;x pos
		STA $206		;y pos
		LDA #$00
		STA $207		;x 0=> 1=<
		STA $208		;y 0=v 1=^
		
		LDA #$00
		STA $20d		;change color?
		LDA #$00
		STA $20e		;color type	0 = white 1=red 2=green 3=blue
		
		LDA #$ff		;color MSB white
		STA $20b
		LDA #$ff		;color LSB white
		STA $20c


iloop:	
		JSR WAIT
		JSR colorch
		JSR draweck

		LDA $207
		cmp #1
		beq xdown
		bne xup

iloopn1:	LDA $208
		cmp #1
		beq ydown
		bne yup
		
iloopn2:	LDA $205
		CMP #90
		BEQ maxx
		LDA $205
		CMP #00
		BEQ minx

iloopn3:	LDA $206
		CMP #59
		BEQ maxy
		LDA $206
		CMP #00
		BEQ miny

		JMP iloop


xdown:	dec $205
		jmp iloopn1
xup:		inc $205
		jmp iloopn1
maxx:	LDA #$01
		STA $207		;X rot =1
		LDA #$01
		STA $20d		;change color!
		JMP iloopn3
minx:	LDA #$00
		STA $207		;X rot =1
		LDA #$01
		STA $20d		;change color!
		JMP iloopn3

ydown:	dec $206
		jmp iloopn2
yup:		inc $206
		jmp iloopn2
maxy:	LDA #$01
		STA $208		;X rot =1
		LDA #$01
		STA $20d		;change color!
		JMP iloop
miny:	LDA #$00
		STA $208		;X rot =1
		LDA #$01
		STA $20d		;change color!
		JMP iloop


;----------------------------------------
colorch:
		LDA $20d
		cmp #1
		bne colorched
		LDA #$00
		STA $20d		

		LDA $20e
		cmp #3
		beq colorchbk
		inc $20e

colorchne:	LDA $20e
		cmp #0
		beq colwhite
		LDA $20e
		cmp #1
		beq colred
		LDA $20e
		cmp #2
		beq colgreen
		LDA $20e
		cmp #3
		beq colblue
		
colorched:
RTS

colorchbk:	LDA #0
		STA $20e
		JMP colorchne

colwhite:	LDA #$0f
		STA $20b
		LDA #$ff
		STA $20c
		jmp colorched

colred:	LDA #$0f
		STA $20b
		LDA #$00
		STA $20c
		jmp colorched
		
colgreen:	LDA #$00
		STA $20b
		LDA #$f0
		STA $20c
		jmp colorched

colblue:	LDA #$00
		STA $20b
		LDA #$0f
		STA $20c
		jmp colorched
		
;----------------------------------------

draweck:	LDA #$75
		STA $2000

		LDA $206		;y
		STA $2001
		CLC
		ADC #7		;y+7
		STA $2001 		;LCD-ZEILENBEREICH FESTLEGEN


		LDA #$15
		STA $2000  		;LCD-BEFEHL

		LDA $205		;x
		STA $2001
		CLC
		ADC #7		;x+7
		STA $2001  		;LCD-SPALTENBEREICH FESTLEGEN


		LDA #$5C
		STA $2000 		;LCD -DATENSTART

		;--------------------------------------------
		LDA #$00
		STA $203  		;X=0 POS.
		STA $204  		;Y=0 POS.


blackloop:	
		LDA #$00
		STA $2001 		;ANS LCD SCHICKEN
		LDA #$00
		STA $2001 		;ANS LCD SCHICKEN

		INC $203 		;X++
		LDA $203 
		CMP #8 		;WENN X=98, DANN NEUE ZEILE
		BNE blackloop
		
		LDA #$00
		STA $203  		;X=0 POS.
		STA $204  		;Y=0 POS.
		
recklloop:	LDA #$00
		STA $2001 		;ANS LCD SCHICKEN
		LDA #$00
		STA $2001 		;ANS LCD SCHICKEN

		LDA $20b
		STA $2001 		;ANS LCD SCHICKEN
		LDA $20c
		STA $2001 		;ANS LCD SCHICKEN

		LDA $20b
		STA $2001 		;ANS LCD SCHICKEN
		LDA $20c
		STA $2001 		;ANS LCD SCHICKEN

		LDA $20b
		STA $2001 		;ANS LCD SCHICKEN
		LDA $20c
		STA $2001 		;ANS LCD SCHICKEN

		LDA $20b
		STA $2001 		;ANS LCD SCHICKEN
		LDA $20c
		STA $2001 		;ANS LCD SCHICKEN

		LDA $20b
		STA $2001 		;ANS LCD SCHICKEN
		LDA $20c
		STA $2001 		;ANS LCD SCHICKEN

		LDA $20b
		STA $2001 		;ANS LCD SCHICKEN
		LDA $20c
		STA $2001 		;ANS LCD SCHICKEN

		LDA #$00
		STA $2001 		;ANS LCD SCHICKEN
		LDA #$00
		STA $2001 		;ANS LCD SCHICKEN


		INC $204 		;y++
		LDA $204 
		CMP #6 		;WENN X=98, DANN NEUE ZEILE
		BNE recklloop
		
		LDA #$00
		STA $203  		;X=0 POS.
		STA $204  		;Y=0 POS.
		

blackloop2:	
		LDA #$00
		STA $2001 		;ANS LCD SCHICKEN
		LDA #$00
		STA $2001 		;ANS LCD SCHICKEN

		INC $203 		;X++
		LDA $203 
		CMP #8 		;WENN X=98, DANN NEUE ZEILE
		BNE blackloop2
		;--------------------------------------------

RTS

CLRLCD:	LDA #$75
		STA $2000

		LDA #0		
		STA $2001
		LDA #66	
		STA $2001 		;LCD-ZEILENBEREICH FESTLEGEN


		LDA #$15
		STA $2000  		;LCD-BEFEHL

		LDA #0		
		STA $2001
		LDA #97		
		STA $2001  		;LCD-SPALTENBEREICH FESTLEGEN


		LDA #$5C
		STA $2000 		;LCD -DATENSTART

		;--------------------------------------------
		LDA #$00
		STA $203  		;X=0 POS.
		STA $204  		;Y=0 POS.


clrloop:	lda #$00
		sta $2001 		;ans LCD schicken
		lda #$00
		sta $2001 		;ans LCD schicken

		inc $203 		;X inkrementieren
		lda $203 
		cmp #98 		;wenn X=98, dann neue Zeile
		bne clrloop
		lda #0
		sta $203 		;X=0
		inc $204 		;Y+1
		lda $204
		cmp #67 		;wenn Y=68, dann letzte Zeile erreicht
		bne clrloop
RTS

INILCD:  	LDA	#$00		;SIEHE DATENBLATT VOM LCD
		STA	$36
		LDA #$03
		STA	$37

		LDA #$30
		STA $2000
		LDA #$04
		STA $2000
		LDA #$3E
		STA $2001

		LDA #$31
		STA $2000
		LDA #$F4
		STA $2000
		LDA #$58
		STA $2001

		LDA #$30
		STA $2000
		LDA #$94
		STA $2000
		LDA #$D1
		STA $2000
		LDA #$CA
		STA $2000

		LDA #$00
		STA $2001
		LDA #$10
		STA $2001
		LDA #$00
		STA $2001
 
		LDA #$31
		STA $2000
		LDA #$32
		STA $2000
 
		LDA #$00
		STA $2001
		LDA #$02
		STA $2001
		LDA #$03
		STA $2001
		LDA #$04
		STA $2001
 
		LDA #$30
		STA $2000
		LDA #$81
		STA $2000
 
		LDA #$1D	
		STA $2001
		LDA #$02
		STA $2001 

		LDA #$20
		STA $2000
		LDA #$0B
		STA $2001

 
		LDA #$30
		STA $2000
		LDA #$A7
		STA $2000
		LDA #$BB
		STA $2000
		LDA #$01
		STA $2001 

		LDA #$BC
		STA $2000
 
		LDA #$00
		STA $2001
		LDA #$00
		STA $2001
		LDA #$06
		STA $2001
 
		LDA #$75
		STA $2000
		LDA #$00
		STA $2001
		LDA #$43
		STA $2001
 
		LDA #$15
		STA $2000
		LDA #$00
		STA $2001
		LDA #$5F
		STA $2001

		LDA #$AF
		STA $2000
		LDA #$30
		STA $2000
RTS  

WAIT:	
		lda #$00
		sta $209
		sta $20a
		
wai:		inc $209
		lda $209
		cmp #$ff
		bne wai
		lda #$00
		sta $209
		inc $20a
		lda $20a
		cmp #$27
		bne wai
RTS

END